## hugin 2025.0~beta1+dfsg

=== CMakeLists.txt ===

# require at least cmake 3.15
cmake_minimum_required(VERSION 3.15 FATAL_ERROR )

# prevent in-tree building
if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
    message(FATAL_ERROR "In-source builds are not allowed.")
endif()

cmake_policy(SET CMP0003 NEW)
if(POLICY CMP0072)
  cmake_policy(SET CMP0072 NEW)
endif()
if(POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)
endif()
if(POLICY CMP0127)
  cmake_policy(SET CMP0127 NEW)
endif()

if(APPLE)
  set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9")
  if (MAC_SELF_CONTAINED_BUNDLE)
      set(CMAKE_LIBRARY_PATH ${CMAKE_SOURCE_DIR}/mac/ExternalPrograms/repository/lib)
      set(CMAKE_INCLUDE_PATH ${CMAKE_SOURCE_DIR}/mac/ExternalPrograms/repository/include ${CMAKE_SOURCE_DIR}/mac/ExternalPrograms/repository/bin)
  endif(MAC_SELF_CONTAINED_BUNDLE)
  # for FindOpenMP
  set(CMAKE_REQUIRED_INCLUDES ${CMAKE_SOURCE_DIR}/mac/ExternalPrograms/repository/include)
endif(APPLE)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/CMakeModules )

##
## Cleaner Debian Packaging (disable by -DDISABLE_DPKG=ON)
##
OPTION (DISABLE_DPKG "Do not use debian scripts to get package dependences" OFF)


IF(NOT DISABLE_DPKG)
  set(ARCH_TRIPLET)
  if(UNIX)
    FIND_PROGRAM(DPKG_ARCHITECTURE_EXECUTABLE dpkg-architecture)
    if(DPKG_ARCHITECTURE_EXECUTABLE)
      EXECUTE_PROCESS(COMMAND dpkg-architecture -qDEB_HOST_MULTIARCH
        OUTPUT_VARIABLE ARCH_TRIPLET
        ERROR_VARIABLE ERROR_ARCH_TRIPLET
        OUTPUT_STRIP_TRAILING_WHITESPACE)
    endif()
  endif()
  if(ARCH_TRIPLET)
    set(SYSTEM_LIB_DIRS /usr/lib /usr/lib/${ARCH_TRIPLET} /usr/local/lib)
  else()
    set(SYSTEM_LIB_DIRS /usr/lib /usr/local/lib)
  endif()
ENDIF()

include(HuginMacros)
include(CheckIncludeFiles)

##  global setup
project(hugin)

# version
set(V_MAJOR 2025)
set(V_MINOR 0)
set(V_PATCH 0)

include(GNUInstallDirs)

#
# Check for mercurial and get current revision
#

IF(EXISTS ${PROJECT_SOURCE_DIR}/.hg)
  FIND_PACKAGE(Hg)
  IF(HG_FOUND)
    EXECUTE_PROCESS(COMMAND ${HG_EXECUTABLE} summary WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}" OUTPUT_VARIABLE _release OUTPUT_STRIP_TRAILING_WHITESPACE)
    foreach(_v_l ${_release})
      if(_v_l MATCHES "^.*: *[^0-9]*\([0-9]+\):\([a-z0-9]+\)")
        set(CPACK_PACKAGE_VERSION_PATCH ${CMAKE_MATCH_1})
        set(HUGIN_WC_REVISION ${CMAKE_MATCH_2})
      endif()
    endforeach()
  ELSE()
    SET(HUGIN_WC_REVISION 0)
  ENDIF()
  SET(HUGIN_PACKAGE_VERSION ${V_MAJOR}.${V_MINOR}.${V_PATCH})
  SET(HUGIN_DEVELOPMENT_VERSION 1)
  FILE(WRITE ${PROJECT_SOURCE_DIR}/rev.txt "${HUGIN_WC_REVISION}")
  MESSAGE("-- Current HG revision is ${HUGIN_WC_REVISION}")
ELSE()
  IF (EXISTS ${PROJECT_SOURCE_DIR}/.svn)
    # comment out the following line to compile an old version from the subversion repository
    MESSAGE(FATAL_ERROR "Hugin subversion repository is not up to date. The development happens now in mercurial repository. Please switch to mercurial. Sorry for the inconsistency")
  ENDIF()

  SET(CPACK_PACKAGE_VERSION_PATCH ${V_PATCH})
  SET(HUGIN_PACKAGE_VERSION ${V_MAJOR}.${V_MINOR}.${V_PATCH})
  SET(HUGIN_WC_REVISION 0)
  FILE(READ "${PROJECT_SOURCE_DIR}/rev.txt" HUGIN_WC_REVISION)
  MESSAGE("-- Current HG revision is ${HUGIN_WC_REVISION}")
  MESSAGE("-- Assuming this is a tarball (release) build for ${HUGIN_PACKAGE_VERSION}")
  SET(HUGIN_DEVELOPMENT_VERSION 0)
ENDIF()

# version to display
IF (HUGIN_DEVELOPMENT_VERSION EQUAL 1)
  set(DISPLAY_VERSION "Pre-Release ${V_MAJOR}.${V_MINOR}.${V_PATCH}.${HUGIN_WC_REVISION}")
ELSE (HUGIN_DEVELOPMENT_VERSION EQUAL 1)
  set(DISPLAY_VERSION "${V_MAJOR}.${V_MINOR}.${V_PATCH}.${HUGIN_WC_REVISION}")
ENDIF (HUGIN_DEVELOPMENT_VERSION EQUAL 1)

# version for internal libraries.
set(HUGIN_LIB_VERSION 0.0)

# set include path for internal libraries before using finding and initializing
# external dependencies. This makes sure that "our" include paths are specified
# before any system includes

include_directories( ${CMAKE_BINARY_DIR}/src )
include_directories( ${CMAKE_SOURCE_DIR}/src/hugin_base )
include_directories( ${CMAKE_SOURCE_DIR}/src/celeste )
include_directories( ${CMAKE_BINARY_DIR}/src/celeste )
include_directories( ${CMAKE_SOURCE_DIR}/src )

# this function is not available on some systems, notably FreeBSD and Windows
include(CheckFunctionExists)
set(CMAKE_REQUIRED_LIBRARIES -lm)
check_function_exists(log1p HAVE_LOG1P)

#
# find dependencies
#
IF (UNIX)
FIND_PACKAGE(PkgConfig)
ENDIF (UNIX)

set(HUGIN_SHARED "1" CACHE STRING "Build shared internal libraries" )

#
# Setup windows search paths for dependencies
#
IF (WIN32)
  ##
  ## The directory that contains the hugin source root is a good
  ## place to look for support packages, so post it in cache.
  ## 
  ## Our FIND_PACKAGE calls modules will search SOURCE_BASE_DIR
  ## after the local standard places  
  ##
  # extract pathname from CMAKE_SOURCE_DIR (note result must be a local var)
  STRING( REGEX REPLACE "(.*)/[^/]+$" "\\1" work "${CMAKE_SOURCE_DIR}" )
  # create the cache entry
  SET( SOURCE_BASE_DIR ${work} CACHE FILEPATH "parent dir of hugin source root" )

  # wxWidgets
  IF(NOT wxWidgets_ROOT_SUFFIX)
    SET( wxWidgets_ROOT_SUFFIX 3.2.0 CACHE STRING "version of wxWidgets." FORCE )
  ENDIF(NOT wxWidgets_ROOT_SUFFIX)
  IF(NOT wxWidgets_ROOT_DIR)
    SET(wxWidgets_ROOT_DIR ${SOURCE_BASE_DIR}/wxWidgets-${wxWidgets_ROOT_SUFFIX})
  ENDIF()
ENDIF(WIN32)

##
## wxWidgets
##
#  This must come before FINDs for tiff, jpeg, png, zlib to enable
#  finding the wxWidgets distributions of those packages (Win32 only).
IF(WIN32)
  FIND_PACKAGE(wxWidgets REQUIRED base core aui xrc html xml adv gl qa propgrid)
ELSE()
# Unix needs also wxWidgets net library
  FIND_PACKAGE(wxWidgets REQUIRED base core aui xrc html xml adv gl net qa propgrid)
ENDIF()

# hugin requires wxwidgets 3.2 or above
IF (UNIX)
  EXECUTE_PROCESS(
    COMMAND ${wxWidgets_CONFIG_EXECUTABLE} --version
    OUTPUT_VARIABLE wxWidgets_VERSION
  )
  STRING(REGEX REPLACE "^([0-9]+\\.[0-9]+)\\..*" "\\1"  wxWidgets_VERSION ${wxWidgets_VERSION})
  IF(wxWidgets_VERSION VERSION_LESS "3.2")
    MESSAGE(FATAL_ERROR "At least wxWidgets 3.2 is required")
  ENDIF()
  # Ubuntu has 2 different devel packages, we need the GUI version
  EXECUTE_PROCESS(
    COMMAND ${wxWidgets_CONFIG_EXECUTABLE} --query-toolkit
    OUTPUT_VARIABLE wxWidgets_TOOLKIT
  )
  IF(wxWidgets_TOOLKIT STREQUAL "base")
    MESSAGE(FATAL_ERROR "wxWidgets is as non-GUI package configured. Check you wxWidgets installation (maybe wxgtkXX-devel is missing)")
  ENDIF()
ENDIF (UNIX)

##
## Graphics libraries
##
# wxWidgets sub-packages will be used if native ones aren't found

FIND_PACKAGE(TIFF REQUIRED)
INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
IF(NOT HUGIN_SHARED)
  # JPEG and PNG are needed when compiling static version
  FIND_PACKAGE(JPEG REQUIRED)
  FIND_PACKAGE(PNG REQUIRED)
ENDIF()

IF(WIN32 AND NOT HUGIN_SHARED)
IF(NOT ${WX_jpeg} MATCHES ${JPEG_LIBRARIES_RELEASE})
MESSAGE(FATAL_ERROR "Using different libjpeg and wxjpeg. This does not work with static libs. Use wxjpeg for libjpeg")
ENDIF()
IF(NOT ${WX_zlib} MATCHES ${ZLIB_LIBRARIES_RELEASE})
MESSAGE(FATAL_ERROR "Using different libzlib and wxzlib. This does not work with static libs. Use wxzlib for libzlib")
ENDIF()
IF(NOT ${WX_png} MATCHES ${PNG_LIBRARIES_RELEASE})
MESSAGE(FATAL_ERROR "Using different libpng and wxpng. This does not work with static libs. Use wxpng for libpng")
ENDIF()
IF(NOT ${WX_tiff} MATCHES ${TIFF_LIBRARIES_RELEASE})
MESSAGE(FATAL_ERROR "Using different libtiff and wxtiff. This does not work with static libs. Use wxtiff for libtiff")
ENDIF()

ENDIF()

FIND_PACKAGE(OpenEXR REQUIRED)
include_directories(${OPENEXR_INCLUDE_DIRS})

FIND_PACKAGE(VIGRA 1.9.0 REQUIRED)
include_directories(${VIGRA_INCLUDE_DIR})

FIND_PACKAGE(EXIV2 REQUIRED)
INCLUDE_DIRECTORIES(${EXIV2_INCLUDE_DIR})

## OpenGL and GLEW

FIND_PACKAGE(OpenGL REQUIRED)
INCLUDE_DIRECTORIES(${OPENGL_INCLUDE_DIR})
SET(OPENGL_GLEW_LIBRARIES ${OPENGL_LIBRARIES})

IF(NOT APPLE AND NOT WIN32)
  OPTION(BUILD_WITH_EGL "Initialize OpenGL context with OpenGL ES (requires libglew with egl support)" OFF)
  IF(BUILD_WITH_EGL)
    IF(NOT OpenGL_EGL_FOUND)
      MESSAGE(FATAL_ERROR "OpenGL ES not found: Install OpenGL ES header or deactivate option BUILD_WITH_EGL")
    ENDIF()
    MESSAGE(STATUS "Use OpenGL ES")
    SET(HAVE_EGL 1)
    INCLUDE_DIRECTORIES(${OPENGL_EGL_INCLUDE_DIRS})
    SET(OPENGL_GLEW_LIBRARIES ${OPENGL_LIBRARIES} ${OPENGL_egl_LIBRARY})
  ELSE()
    UNSET(HAVE_EGL)
  ENDIF()
ENDIF()

IF (APPLE)
  FIND_PACKAGE(GLUT REQUIRED)
  INCLUDE_DIRECTORIES(${GLUT_INCLUDE_DIR})
  SET(OPENGL_GLEW_LIBRARIES ${OPENGL_GLEW_LIBRARIES} ${GLUT_LIBRARIES})
ENDIF()
OPTION(BUILD_WITH_EPOXY "Use libepoxy instead of glew library for OpenGL helper functions" OFF)
IF(BUILD_WITH_EPOXY)
  FIND_PACKAGE(EPOXY REQUIRED)
  INCLUDE_DIRECTORIES(${EPOXY_INCLUDE_DIR})
  SET(OPENGL_GLEW_LIBRARIES ${OPENGL_GLEW_LIBRARIES} ${EPOXY_LIBRARIES})
  SET(HAVE_EPOXY 1)
ELSE()
  FIND_PACKAGE(GLEW REQUIRED)
  INCLUDE_DIRECTORIES(${GLEW_INCLUDE_DIR})
  SET(OPENGL_GLEW_LIBRARIES ${OPENGL_GLEW_LIBRARIES} ${GLEW_LIBRARIES})
  IF(NOT HUGIN_SHARED OR NOT WIN32)
    ADD_DEFINITIONS(-DGLEW_STATIC)
  ENDIF()
  UNSET(HAVE_EPOXY)
ENDIF()

IF(NOT APPLE AND NOT WIN32)
# on Linux we need the X11 header to get the monitor profile
# when compiled without EGL support also the GPU supports needs
# the X11 header, when using EGL support the X11 header are not
# needed for the GPU part, only for the monitor profile
MESSAGE(STATUS "Searching X11 header")
FIND_PACKAGE(X11 REQUIRED)
ENDIF()
##
## Panotools
##

FIND_PACKAGE(PANO13 2.9.19 REQUIRED)

IF(PANO13_FOUND)
  SET(PANO_LIBRARIES ${PANO13_LIBRARIES})
  SET(PANO_INCLUDE_DIR ${PANO13_INCLUDE_DIR})
ELSE(PANO13_FOUND)
  MESSAGE(SEND_ERROR "libpano13 required")
ENDIF(PANO13_FOUND) 
INCLUDE_DIRECTORIES(${PANO_INCLUDE_DIR})

# Check CXX11 compiler
SET(CMAKE_CXX_STANDARD 17)
SET(CMAKE_CXX_STANDARD_REQUIRED ON)
# necessary threads lib
SET(THREADS_PREFER_PTHREAD_FLAG ON)
FIND_PACKAGE(Threads REQUIRED)

IF(WIN32)
  # for Windows Vista support
  ADD_DEFINITIONS(-DPSAPI_VERSION=1)
ENDIF(WIN32)

# find enblend-enfuse base path
IF(WIN32)
  FIND_PATH(ENBLEND_DIR bin/enblend.exe enblend.exe
    PATHS 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.2-win64 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.2-win32 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.5-win64 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.5-win32 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.4-win64 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.4-win32 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.3-win64 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.3-win32 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.2-win64 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.2-win32 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.1-win64 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.1-win32 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.1 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.0
      ${SOURCE_BASE_DIR}/enblend-3.1
      ${SOURCE_BASE_DIR}/enblend-enfuse-3.2
      ${SOURCE_BASE_DIR}/enblend.build
      ${SOURCE_BASE_DIR}/enblend
    DOC "Location of enblend"
    NO_DEFAULT_PATH
  )
  IF(NOT ENBLEND_DIR)
    MESSAGE(FATAL_ERROR "enblend-enfuse files not found.")
  ENDIF()
ENDIF()

# littleCMS 2 now
FIND_PACKAGE(LCMS2 REQUIRED)
INCLUDE_DIRECTORIES(${LCMS2_INCLUDE_DIR})
IF(WIN32)
  IF(HUGIN_SHARED AND NOT VCPKG_TOOLCHAIN)
    ADD_DEFINITIONS(-DCMS_DLL)
  ENDIF()
ENDIF()

FIND_PACKAGE(FLANN)

IF(NOT FLANN_FOUND)
  INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/src/foreign)
ENDIF(NOT FLANN_FOUND)

FIND_PACKAGE(FFTW)
IF(FFTW_FOUND)
  MESSAGE(STATUS "Found FFTW library. Activated support for FFT fast cross correlation used by fine-tune feature.")
  INCLUDE_DIRECTORIES(${FFTW_INCLUDE_DIR})
  SET(HAVE_FFTW TRUE)
ELSE()
  MESSAGE(STATUS "Not found FFTW library. Deactivating support for FFT fast cross correlation used by fine-tune feature.")
ENDIF()

# Check for OpenMP

=== src/CMakeLists.txt ===

# define common sets of libraries, used by different subdirectories
SET(common_libs huginbase ${PANO_LIBRARIES} huginlevmar ${GLEW_LIBRARIES})
IF (MSVC)
  SET(common_libs hugingetopt ${common_libs})
  include_directories( ${CMAKE_SOURCE_DIR}/src/foreign/getopt/include )
ENDIF()
IF(LAPACK_FOUND)
  SET(common_libs ${common_libs} ${LAPACK_LIBRARIES})
ENDIF()
IF(FFTW_FOUND)
  SET(common_libs ${common_libs} ${FFTW_LIBRARIES})
ENDIF()

set(image_libs ${VIGRA_LIBRARIES} ${OPENEXR_LIBRARIES} ${JPEG_LIBRARIES} ${TIFF_LIBRARIES}
    ${PNG_LIBRARIES} ${ZLIB_LIBRARIES} ${EXIV2_LIBRARIES})

SET(common_libs ${common_libs} ${image_libs} ${LCMS2_LIBRARIES} Threads::Threads)

add_subdirectory(celeste)
add_subdirectory(foreign)
add_subdirectory(hugin_base)
add_subdirectory(tools)
add_subdirectory(deghosting)

# hsi contains the Python interface. This add_ should be conditional,
# depending on availability of SWIG and Python.
# this have to come before hugin1 directory
IF(BUILD_HSI)
add_subdirectory(hugin_script_interface)
ENDIF()

add_subdirectory(hugin_cpfind)
add_subdirectory(translations)
add_subdirectory(hugin1)

=== src/celeste/CMakeLists.txt ===
#    Copyright (C) 2008 by Tim Nugent
#    timnugent@gmail.com
# 
#    This file is part of hugin.
# 
#    Hugin is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 2 of the License, or
#    (at your option) any later version.
#  
#    Hugin is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#  
#    You should have received a copy of the GNU General Public License
#    along with Hugin  If not, see <http://www.gnu.org/licenses/>.
 
IF(NOT WIN32)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
ENDIF(NOT WIN32)

# a list of all files belonging to celeste library

SET(CELESTE_SRC
CelesteGlobals.cpp
CelesteGlobals.h
Celeste.cpp
Celeste.h
ContrastFilter.cpp
ContrastFilter.h
Gabor.cpp
Gabor.h
GaborGlobal.h
GaborFilter.cpp
GaborFilter.h
GaborJet.cpp
GaborJet.h
ImageFile.cpp
ImageFile.h
PGMImage.cpp
PGMImage.h
svm.cpp
svm.h
Utilities.cpp
Utilities.h
)

IF (${HUGIN_SHARED_LIBS})
    # messages are quite obtrusive in windows cmakesetup.exe
    IF (NOT WIN32)
	#message("Using these CMAKE_CXX_FLAGS : ${CMAKE_CXX_FLAGS}")
	ENDIF (NOT WIN32)
	ADD_LIBRARY(celeste SHARED ${CELESTE_SRC})
	TARGET_LINK_LIBRARIES(celeste huginbase ${common_libs})
	set_target_properties(celeste PROPERTIES VERSION ${HUGIN_LIB_VERSION})
    IF(WIN32)
      install(TARGETS celeste RUNTIME DESTINATION ${BINDIR})
    ELSEIF(${HUGIN_LIBS_PRIVATE_DIR})
      install(TARGETS celeste LIBRARY DESTINATION ${LIBDIR}/hugin NAMELINK_SKIP)
    ELSE(WIN32)
      install(TARGETS celeste LIBRARY DESTINATION ${LIBDIR} NAMELINK_SKIP)
    ENDIF(WIN32)
ELSE (${HUGIN_SHARED_LIBS})
    # messages are quite obtrusive in windows cmakesetup.exe
    IF (NOT WIN32)
    	#message("Using these CMAKE_CXX_FLAGS : ${CMAKE_CXX_FLAGS}")
	ENDIF (NOT WIN32)	
	ADD_LIBRARY(celeste STATIC ${CELESTE_SRC})
	TARGET_LINK_LIBRARIES(celeste huginbase ${common_libs})
	set_target_properties(celeste PROPERTIES VERSION ${HUGIN_LIB_VERSION})
ENDIF (${HUGIN_SHARED_LIBS})

# standalone
ADD_EXECUTABLE(celeste_standalone ../hugin_config.h  Main.cpp )
target_link_libraries( celeste_standalone celeste ${image_libs} ${common_libs})

SET (CELESTE_MODEL
	data/celeste.model
)

INSTALL(TARGETS celeste_standalone DESTINATION ${BINDIR}) 
INSTALL(FILES ${CELESTE_MODEL} DESTINATION ${HUGINDATADIR}/data)

#add_subdirectory(training)

=== src/hugin_base/CMakeLists.txt ===

# a list of all files belonging to hugin base library

SET(HUGIN_BASE_SRC
algorithms/nona/NonaFileStitcher.cpp
algorithms/basic/CalculateCPStatistics.cpp
algorithms/basic/CalculateMeanExposure.cpp
algorithms/basic/CalculateOptimalScale.cpp
algorithms/basic/CalculateOptimalROI.cpp
algorithms/basic/RotatePanorama.cpp
algorithms/basic/TranslatePanorama.cpp
algorithms/basic/StraightenPanorama.cpp
algorithms/basic/CalculateOverlap.cpp
algorithms/basic/LayerStacks.cpp
algorithms/nona/CalculateFOV.cpp
algorithms/nona/CenterHorizontally.cpp
algorithms/nona/FitPanorama.cpp
algorithms/nona/ComputeImageROI.cpp
algorithms/optimizer/ImageGraph.cpp
algorithms/optimizer/PhotometricOptimizer.cpp
algorithms/optimizer/PTOptimizer.cpp
algorithms/point_sampler/PointSampler.cpp
algorithms/control_points/CleanCP.cpp
appbase/ProgressDisplay.cpp
huginapp/CachedImageRemapper.cpp
huginapp/ImageCache.cpp
hugin_math/eig_jacobi.cpp
hugin_math/hugin_math.cpp
hugin_math/Matrix3.cpp
hugin_math/Vector3.cpp
hugin_utils/alphanum.cpp
hugin_utils/utils.cpp
lensdb/LensDB.cpp
lines/FindLines.cpp 
lines/FindN8Lines.cpp
nona/SpaceTransform.cpp
nona/Stitcher1.cpp
nona/Stitcher2.cpp
nona/Stitcher3.cpp
nona/Stitcher4.cpp
nona/Stitcher.cpp
nona/StitcherOptions.cpp
panodata/ControlPoint.cpp
panodata/Lens.cpp
panodata/Mask.cpp
panodata/Panorama.cpp
panodata/PanoramaOptions.cpp
panodata/PanoramaVariable.cpp
panodata/ParseExp.cpp
panodata/PTScriptParsing.cpp
panodata/SrcPanoImage.cpp
panodata/ImageVariableGroup.cpp
panodata/StandardImageVariableGroups.cpp
panodata/Exiv2Helper.cpp
panotools/PanoToolsInterface.cpp
panotools/PanoToolsOptimizerWrapper.cpp
panotools/PanoToolsUtils.cpp
panotools/PanoToolsTransformGPU.cpp
vigra_ext/emor.cpp
vigra_ext/ImageTransformsGPU.cpp
)

SET(HUGIN_BASE_HEADER
hugin_basic.h
algorithms/PanoramaAlgorithm.h
algorithms/StitcherAlgorithm.h
algorithms/basic/CalculateCPStatistics.h
algorithms/basic/CalculateMeanExposure.h
algorithms/basic/CalculateOptimalScale.h
algorithms/basic/CalculateOptimalROI.h
algorithms/basic/RotatePanorama.h
algorithms/basic/TranslatePanorama.h
algorithms/basic/StraightenPanorama.h
algorithms/basic/CalculateOverlap.h
algorithms/basic/LayerStacks.h
algorithms/control_points/CleanCP.h
algorithms/nona/NonaFileStitcher.h
algorithms/nona/CalculateFOV.h
algorithms/nona/CenterHorizontally.h
algorithms/nona/FitPanorama.h
algorithms/nona/ComputeImageROI.h
algorithms/optimizer/ImageGraph.h
algorithms/optimizer/PhotometricOptimizer.h
algorithms/optimizer/PTOptimizer.h
algorithms/point_sampler/PointSampler.h
appbase/DocumentData.h
appbase/ProgressDisplay.h
huginapp/CachedImageRemapper.h
huginapp/ImageCache.h
hugin_math/eig_jacobi.h
hugin_math/hugin_math.h
hugin_math/Matrix3.h
hugin_math/Vector3.h
hugin_utils/alphanum.h
hugin_utils/openmp_lock.h
hugin_utils/platform.h
hugin_utils/stl_utils.h
hugin_utils/utils.h
lensdb/LensDB.h
lines/FindLines.h
lines/FindN8Lines.h
lines/LinesTypes.h
nona/ImageRemapper.h
nona/RemappedPanoImage.h
nona/SpaceTransform.h
nona/Stitcher.h
nona/StitcherOptions.h
panodata/ControlPoint.h
panodata/Exiv2Helper.h
panodata/ImageVariable.h
panodata/ImageVariableGroup.h
panodata/ImageVariableTranslate.h
panodata/image_variables.h
panodata/Lens.h
panodata/Mask.h
panodata/OptimizerSwitches.h
panodata/Panorama.h
panodata/PanoramaData.h
panodata/PanoramaOptions.h
panodata/PanoramaVariable.h
panodata/ParseExp.h
panodata/PTScriptParsing.h
panodata/SrcPanoImage.h
panodata/StandardImageVariableGroups.h
panotools/PanoToolsInterface.h
panotools/PanoToolsOptimizerWrapper.h
panotools/PanoToolsUtils.h
photometric/ResponseTransform.h
vigra_ext/BlendPoisson.h
vigra_ext/Correlation.h
vigra_ext/cms.h
vigra_ext/emor.h
vigra_ext/FileRAII.h
vigra_ext/FitPolynom.h
vigra_ext/FunctorAccessor.h
vigra_ext/HDRUtils.h
vigra_ext/ImageTransforms.h
vigra_ext/ImageTransformsGPU.h
vigra_ext/InterestPoints.h
vigra_ext/Interpolators.h
vigra_ext/lut.h
vigra_ext/openmp_vigra.h
vigra_ext/Pyramid.h
vigra_ext/pyramid2.h
vigra_ext/ransac.h
vigra_ext/ReduceOpenEXR.h
vigra_ext/ROIImage.h
vigra_ext/StitchWatershed.h
vigra_ext/tiffUtils.h
vigra_ext/utils.h
vigra_ext/VignettingCorrection.h
)

IF (${HUGIN_SHARED_LIBS})
  add_library(huginbase SHARED ${HUGIN_BASE_SRC} ${HUGIN_BASE_HEADER})
  target_link_libraries(huginbase Threads::Threads ${X11_X11_LIB})
  set_target_properties(huginbase PROPERTIES VERSION ${HUGIN_LIB_VERSION})
  IF(WIN32)
    install(TARGETS huginbase RUNTIME DESTINATION ${BINDIR})
  ELSEIF(${HUGIN_LIBS_PRIVATE_DIR})
    install(TARGETS huginbase LIBRARY DESTINATION ${LIBDIR}/hugin NAMELINK_SKIP)
  ELSE(WIN32)
    install(TARGETS huginbase LIBRARY DESTINATION ${LIBDIR} NAMELINK_SKIP)
  ENDIF(WIN32)
ELSE (${HUGIN_SHARED_LIBS})
  add_library(huginbase STATIC ${HUGIN_BASE_SRC} ${HUGIN_BASE_HEADER})
ENDIF (${HUGIN_SHARED_LIBS})

TARGET_LINK_LIBRARIES(huginbase huginlevmar ${VIGRA_LIBRARIES} 
        ${EXIV2_LIBRARIES} ${PANO_LIBRARIES}
        ${TIFF_LIBRARIES} ${LAPACK_LIBRARIES}
        ${OPENGL_GLEW_LIBRARIES} Threads::Threads
        ${SQLITE3_LIBRARIES} ${LCMS2_LIBRARIES})

IF (MINGW)
    # exiv2 needs psapi and ws2_32 when compiling with Mingw
    TARGET_LINK_LIBRARIES(huginbase psapi ws2_32)
ENDIF() 

source_group(Lines REGULAR_EXPRESSION lines/*)
source_group(Vigra_ext REGULAR_EXPRESSION vigra_ext/*)
source_group(Algorithm REGULAR_EXPRESSION algorithm/*)
source_group(Panodata REGULAR_EXPRESSION panodata/*)
source_group(Panotools REGULAR_EXPRESSION panotools/*)
source_group(Nona REGULAR_EXPRESSION nona/*)
source_group(LensDB REGULAR_EXPRESSION lensdb/*)
source_group(Hugin_utils REGULAR_EXPRESSION hugin_utils/*)
source_group(Hugin_math REGULAR_EXPRESSION hugin_math/*)
source_group(AppBase REGULAR_EXPRESSION "(appbase/*|huginapp/*)")

=== src/hugin_cpfind/CMakeLists.txt ===
include_directories(.)

add_subdirectory(localfeatures)
add_subdirectory(cpfind)

=== src/tools/CMakeLists.txt ===

add_executable(fulla fulla.cpp)
target_link_libraries(fulla ${common_libs} ${image_libs})
# for expanding wildcard with MSVC
if(MSVC)
  set_target_properties(fulla PROPERTIES LINK_FLAGS "setargv.obj")
endif(MSVC)

add_executable(nona nona.cpp)
target_link_libraries(nona ${common_libs} ${image_libs} ${OPENGL_GLEW_LIBRARIES})

#add_executable(autocreate autocreate.cpp)
#target_link_libraries(autocreate ${common_libs} ${image_libs})

add_executable(autooptimiser autooptimiser.cpp ExtractPoints.h)
target_link_libraries(autooptimiser ${common_libs} ${image_libs})

add_executable(vig_optimize vig_optimize.cpp ExtractPoints.h)
target_link_libraries(vig_optimize ${common_libs} ${image_libs})

add_executable(align_image_stack align_image_stack.cpp)
target_link_libraries(align_image_stack ${common_libs} ${image_libs} ${OPENGL_GLEW_LIBRARIES})
# for expanding wildcard with MSVC
if(MSVC)
  set_target_properties(align_image_stack PROPERTIES LINK_FLAGS "setargv.obj")
endif(MSVC)


add_executable(linefind linefind.cpp)
target_link_libraries(linefind ${common_libs} ${image_libs})

add_executable(geocpset geocpset.cpp)
target_link_libraries(geocpset ${common_libs})

add_executable(tca_correct tca_correct.cpp)
target_link_libraries(tca_correct ${common_libs} ${image_libs})

add_executable(cpclean cpclean.cpp)
target_link_libraries(cpclean ${common_libs} )

add_executable(checkpto checkpto.cpp)
target_link_libraries(checkpto ${common_libs} )

add_executable(pto_merge pto_merge.cpp)
target_link_libraries(pto_merge ${common_libs} )

add_executable(pto_template pto_template.cpp)
target_link_libraries(pto_template ${common_libs} )

add_executable(pto_mask pto_mask.cpp)
target_link_libraries(pto_mask ${common_libs} )

add_executable(pto_gen pto_gen.cpp)
target_link_libraries(pto_gen ${common_libs} )

add_executable(pano_trafo pano_trafo.cpp)
target_link_libraries(pano_trafo ${common_libs} )

add_executable(pano_modify IniParser.h IniParser.cpp PanoOptionsFromIni.h PanoOptionsFromIni.cpp pano_modify.cpp)
target_link_libraries(pano_modify ${common_libs} )

add_executable(pto_var pto_var.cpp)
target_link_libraries(pto_var ${common_libs})

add_executable(pto_lensstack pto_lensstack.cpp)
target_link_libraries(pto_lensstack ${common_libs})

add_executable(pto_move pto_move.cpp)
target_link_libraries(pto_move ${common_libs})
# for expanding wildcard with MSVC
if(MSVC)
  set_target_properties(pto_move PROPERTIES LINK_FLAGS "setargv.obj")
endif(MSVC)

add_executable(hugin_hdrmerge hugin_hdrmerge.cpp ../deghosting/deghosting.cpp ../deghosting/deghosting.h ../deghosting/khan.h ../deghosting/support.h ../deghosting/algtinyvector.h)
target_link_libraries(hugin_hdrmerge ${common_libs} ${image_libs} )

add_executable(hugin_lensdb hugin_lensdb.cpp)
target_link_libraries(hugin_lensdb ${common_libs})

add_executable(verdandi verdandi.cpp)
target_link_libraries(verdandi ${common_libs} ${image_libs})

# for expanding wildcard with MSVC
if(MSVC)
  set_target_properties(verdandi PROPERTIES LINK_FLAGS "setargv.obj")
endif(MSVC)

add_executable(hugin_stacker stacker.cpp)
target_link_libraries(hugin_stacker ${common_libs} ${image_libs})

# for expanding wildcard with MSVC
if(MSVC)
  set_target_properties(hugin_stacker PROPERTIES LINK_FLAGS "setargv.obj")
endif(MSVC)


install(TARGETS nona vig_optimize autooptimiser fulla align_image_stack linefind geocpset
        tca_correct cpclean checkpto hugin_hdrmerge pano_trafo pano_modify pto_merge 
        pto_gen pto_var pto_lensstack pto_template pto_mask pto_move hugin_lensdb verdandi
        hugin_stacker
        DESTINATION ${BINDIR})

IF(UNIX)
  INSTALL(FILES pto_gen.desktop DESTINATION ${DATADIR}/applications)
ENDIF(UNIX)

=== src/translations/CMakeLists.txt ===
# This file is part of hugin, a GUI for the panorama tools suite
# Licence details can be found in the file COPYING.txt.
#
# Copyright (c) 2013 Kornel Benko, <Kornel.Benko@berlin.de>
#

find_package(MSGFMT QUIET REQUIRED)

# simply use all po files and hugin.pot from the source directory
FILE(GLOB PO_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*.po")

ADD_TRANSLATIONS("${CMAKE_CURRENT_SOURCE_DIR}/hugin.pot" ${PO_FILES})

IF(APPLE)
  add_custom_command(
    TARGET translations
    POST_BUILD
    COMMAND ${CMAKE_SOURCE_DIR}/mac/CopyTranslations.sh ${CMAKE_CURRENT_BINARY_DIR})
ENDIF()

=== platforms/linux/appdata/CMakeLists.txt ===
IF (UNIX)
# install appdata files
  INSTALL(FILES calibrate_lens_gui.appdata.xml hugin.appdata.xml PTBatcherGUI.appdata.xml DESTINATION ${DATADIR}/metainfo)
ENDIF (UNIX)

=== src/celeste/training/CMakeLists.txt ===
#    Copyright (C) 2008 by Tim Nugent
#    timnugent@gmail.com
#    License: GPLv2+

ADD_EXECUTABLE( celeste_train CelesteTrain.cpp )
target_link_libraries( celeste_train celeste ${image_libs} ${wxWidgets_LIBRARIES})

=== src/foreign/flann/CMakeLists.txt ===

add_definitions(-D_FLANN_VERSION=1.7.1)

file(GLOB_RECURSE C_SOURCES flann.cpp)
file(GLOB_RECURSE CPP_SOURCES flann_cpp.cpp)

IF (${HUGIN_SHARED_LIBS})

IF(CMAKE_SYSTEM_NAME STREQUAL "Linux" AND CMAKE_COMPILER_IS_GNUCC)
    add_library(flann_cpp_s STATIC ${CPP_SOURCES})
    set_target_properties(flann_cpp_s PROPERTIES COMPILE_FLAGS -fPIC)
    set_property(TARGET flann_cpp_s PROPERTY COMPILE_DEFINITIONS FLANN_STATIC)

    add_library(flann_cpp SHARED "")
    target_link_libraries(flann_cpp -Wl,-whole-archive flann_cpp_s -Wl,-no-whole-archive)
    set_target_properties(flann_cpp PROPERTIES VERSION ${HUGIN_LIB_VERSION}) 

    IF(${HUGIN_LIBS_PRIVATE_DIR})
        install(TARGETS flann_cpp LIBRARY DESTINATION ${LIBDIR}/hugin NAMELINK_SKIP ARCHIVE DESTINATION ${LIBDIR}/hugin  )
    ELSE()
        install(TARGETS flann_cpp LIBRARY DESTINATION ${LIBDIR} NAMELINK_SKIP ARCHIVE DESTINATION ${LIBDIR} )
    ENDIF()
ELSE()
    add_library(flann_cpp SHARED ${CPP_SOURCES})
    IF(WIN32)
        install(TARGETS flann_cpp RUNTIME DESTINATION ${BINDIR} ARCHIVE DESTINATION ${BINDIR} )
    ELSEIF(${HUGIN_LIBS_PRIVATE_DIR})
        install(TARGETS flann_cpp LIBRARY DESTINATION ${LIBDIR}/hugin NAMELINK_SKIP ARCHIVE DESTINATION ${LIBDIR}/hugin  )
    ELSE(WIN32)
        install(TARGETS flann_cpp LIBRARY DESTINATION ${LIBDIR} NAMELINK_SKIP ARCHIVE DESTINATION ${LIBDIR} )
    ENDIF(WIN32)

ENDIF()

ELSE(${HUGIN_SHARED_LIBS})
    add_library(flann_cpp STATIC ${CPP_SOURCES})
    set_property(TARGET flann_cpp PROPERTY COMPILE_DEFINITIONS FLANN_STATIC)    
ENDIF(${HUGIN_SHARED_LIBS})

=== src/foreign/levmar/CMakeLists.txt ===

# levmar library source files
set(LEVMAR_SOURCE
    lm.c Axb.c misc.c 
    # the following files are not needed for Hugin
    # therefore commenting out
    # lmlec.c lmbc.c lmblec.c lmbleic.c
)
set(LEVMAR_HEADER
    levmar.h misc.h compiler.h
)

ADD_LIBRARY(huginlevmar STATIC ${LEVMAR_SOURCE} ${LEVMAR_HEADER})

IF (NOT MSVC AND NOT MINGW)
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
  SET_TARGET_PROPERTIES(huginlevmar PROPERTIES COMPILE_FLAGS -fPIC)
ENDIF (NOT MSVC AND NOT MINGW)

IF(LAPACK_FOUND)
  ADD_DEFINITIONS(-DHAVE_LAPACK)
ENDIF(LAPACK_FOUND)

=== src/hugin1/base_wx/CMakeLists.txt ===

SET(HUGIN_WX_BASE_SRC wxImageCache.cpp MyProgressDialog.cpp PTWXDlg.cpp
                      huginConfig.cpp MyExternalCmdExecDialog.cpp platform.cpp
                      RunStitchPanel.cpp LensTools.cpp wxLensDB.cpp HFOVDialog.cpp
                      Command.cpp PanoCommand.cpp wxPanoCommand.cpp CommandHistory.cpp
                      Executor.cpp AssistantExecutor.cpp StitchingExecutor.cpp wxcms.cpp 
                      wxPlatform.cpp wxutils.cpp GraphTools.cpp)
SET(HUGIN_WX_BASE_HEADER wxImageCache.h MyProgressDialog.h PTWXDlg.h
                      huginConfig.h MyExternalCmdExecDialog.h platform.h
                      RunStitchPanel.h LensTools.h wxLensDB.h HFOVDialog.h
                      Command.h PanoCommand.h wxPanoCommand.h CommandHistory.h
                      Executor.h AssistantExecutor.h StitchingExecutor.h wxcms.h 
                      wxPlatform.h wxutils.h GraphTools.h )

IF (${HUGIN_SHARED_LIBS})
  add_library(huginbasewx SHARED ${HUGIN_WX_BASE_SRC} ${HUGIN_WX_BASE_HEADER})
  target_link_libraries(huginbasewx ${wxWidgets_LIBRARIES} huginbase ${common_libs})
  set_target_properties(huginbasewx PROPERTIES VERSION ${HUGIN_LIB_VERSION})
  IF(WIN32)
    install(TARGETS huginbasewx RUNTIME DESTINATION ${BINDIR})
  ELSEIF(${HUGIN_LIBS_PRIVATE_DIR})
    install(TARGETS huginbasewx LIBRARY DESTINATION ${LIBDIR}/hugin NAMELINK_SKIP)
  ELSE(WIN32)
    install(TARGETS huginbasewx LIBRARY DESTINATION ${LIBDIR} NAMELINK_SKIP)
  ENDIF(WIN32)
ELSE (${HUGIN_SHARED_LIBS})
  add_library(huginbasewx STATIC ${HUGIN_WX_BASE_SRC} ${HUGIN_WX_BASE_HEADER})
ENDIF (${HUGIN_SHARED_LIBS})

IF(BUILD_HSI)
target_link_libraries(huginbasewx hugin_python_interface)
ENDIF()

INSTALL(FILES hugin_exiftool_copy.arg hugin_exiftool_final_example.arg DESTINATION ${HUGINDATADIR}/data)

=== debian/changelog ===
hugin (2025.0~beta1+dfsg-1) experimental; urgency=medium

  * New upstream version.
  * Update build-dependency list.
  * Run wrap-and-sort -ast.
  * Ship newly availble hugin_toolbox binary.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 05 Oct 2025 15:44:10 +0200

=== debian/control ===
Source: hugin
Section: graphics
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Metzler <ametzler@debian.org>,
# hugin can use Boost::Signal or in Boost >= 1.54 Boost::Signal2 which is
# shipped in libboost-dev.
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 cmake (>= 3.15),
 libepoxy-dev,
 libexiv2-dev (>= 0.12),
 libfftw3-dev,
 libflann-dev,
 liblcms2-dev,
 libopenexr-dev,
 libpano13-dev (>= 2.9.19~beta1),
 libsqlite3-dev,
 libtiff-dev,
 libvigraimpex-dev (>=1.9),
 libwxgtk3.2-dev,
 libx11-dev,
 pkgconf,
 python3-dev,
 python3-setuptools,
 swig (>= 2.0.4),
 zlib1g-dev,
Build-Conflicts:
 wx2.6-headers,
 wx2.8-headers,
 wx3.0-headers,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: http://hugin.sourceforge.net/
Vcs-Git: https://salsa.debian.org/debian-phototools-team/hugin.git
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/hugin

Package: hugin
Architecture: any
Depends:
 enblend (>= 3.2),
 enfuse,
 hugin-tools (= ${binary:Version}),
 libimage-exiftool-perl,
 make,
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 hugin-bin (<< 0.7.0~svn),
Replaces:
 hugin-bin (<< 0.7.0~svn),
 hugin-data (<< 0.7.0~svn),
 hugin-tools (<< 0.7.0~svn),
Suggests:
 dcraw | rawtherapee | darktable,
Description: panorama photo stitcher - GUI tools
 Hugin is a panorama photo stitching program. Essentially, Hugin is a
 GUI frontend for Panorama Tools. Stitching is accomplished by using
 several overlapping photos taken from the same location, and using
 control points to align and transform the photos so that they can be
 blended together to form a larger image. Hugin allows for the easy
 creation of control points between two images, optimization of the
 image transforms, and much more.
 .
 This package includes the following graphical interfaces, using the
 command-line tools provided in the hugin-tools package:
  * hugin                - Hugin panorama creator.
  * hugin_stitch_project - Hugin batch stitcher.
  * PTBatcherGUI         - Batch controller for the stitching process.
  * calibrate_lens_gui   - Lens calibration tool.

Package: hugin-tools
Architecture: any
Depends:
 hugin-data (= ${source:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Breaks:
 hugin-bin (<< 0.7.0~svn),
 ${python3:Breaks},
Replaces:
 hugin-bin (<< 0.7.0~svn),
Recommends:
 libpano13-bin,
Provides:
 python-hsi,
Description: panorama photo stitcher - commandline tools
 Hugin is a panorama photo stitching program.
 .
 This package includes command-line tools used by hugin and other
 packages for image stitching and High Dynamic Range (HDR) images:
  * align_image_stack  - Align overlapping images for HDR creation.
  * autooptimiser      - Optimize image positions.
  * celeste_standalone - Remove cloud-like control points.
  * cpclean            - Remove wrong control points.
  * cpfind             - Patent-free control-point detector
  * deghosting_mask    - Creates mask for removing ghosting in images.
  * fulla              - Correct lens distortion, vignetting, and
                         chromatic aberration.
  * geocpset           - Set geometric control points.
  * hugin_executor     - CLI stitching tool.
  * hugin_hdrmerge     - Merge overlapping images.
  * hugin_lensdb       - Hugin lens database maintenance.
  * icpfind            - Control-point detector wrapper program.
  * linefind           - Detect vertical features in images.
  * nona               - Remap images. (Also does simple stitching.)
  * pano_modify        - Change output parameters of project file.
  * pto_gen            - Generate a Hugin project file from a list of images.
  * pto_lensstack      - Modify assigned lenses and stack in pto files.
  * pto_mask           - Apply a mask.
  * pto_merge          - Merges two or more Hugin project files.
  * pto_move           - Move a project file with all images in it.
  * pto_template       - Apply a template file.
  * pto_var            - Change image variables inside Hugin .pto project
                         files
  * tca_correct        - Calculate transverse chromatic aberration.
  * verdandi           - Blend images using watershed algorithm.
  * vig_optimize       - Determine the radial vignetting.

Package: hugin-data
Architecture: all
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Breaks:
 ${python3:Breaks},
# imports of included plugins
Suggests:
 python-wxgtk4.0,
Description: panorama photo stitcher - common data files
 Hugin is a panorama photo stitching program.
 .
 This package includes the data files needed by the hugin and
 hugin-tools packages.

## hugin 2025.0~rc1%2Bdfsg

=== debian/tests/control ===
Tests:
 simple.pano.test,
Depends:
 hugin,
Restrictions:
 allow-stderr,

## hugin 2025.0~rc1+dfsg

=== platforms/linux/CMakeLists.txt ===
ADD_SUBDIRECTORY(appdata)
ADD_SUBDIRECTORY(icons)

=== src/hugin1/CMakeLists.txt ===

include_directories( ${CMAKE_SOURCE_DIR}/src/hugin1 )

INCLUDE(${wxWidgets_USE_FILE})

# do we need to define _UNICODE on windows?
IF(WIN32)
  ADD_DEFINITIONS(-D_UNICODE -DUNICODE)
ENDIF(WIN32)

# populate correct dpi aware manifest from wxWidgets
IF(WIN32)
  IF(CMAKE_SIZEOF_VOID_P EQUAL 8) 
    # 64 bit build
    FIND_FILE(WINDOWS_DPI_MANIFEST 
      NAMES amd64_dpi_aware_pmv2.manifest amd64-dpi-aware-pmv2.manifest wx_dpi_aware_pmv2.manifest 
      PATHS "${wxWidgets_ROOT_DIR}/include/wx/msw/"
    )
  ELSE()
    # 32 bit build
    FIND_FILE(WINDOWS_DPI_MANIFEST 
      NAMES wx_dpi_aware_pmv2.manifest wx-dpi-aware-pmv2.manifest
      PATHS "${wxWidgets_ROOT_DIR}/include/wx/msw/"
    )
  ENDIF()
  IF(NOT WINDOWS_DPI_MANIFEST)
    MESSAGE(FATAL_ERROR "Manifest in wx directory not found. Is wxWidgets not new enough or corrupted?")
  ENDIF()
ENDIF()

add_subdirectory(base_wx)
add_subdirectory(stitch_project)
add_subdirectory(icpfind)
add_subdirectory(executor)
add_subdirectory(hugin)
add_subdirectory(ptbatcher)
add_subdirectory(calibrate_lens)
add_subdirectory(toolbox)

=== src/hugin_script_interface/plugins/CMakeLists.txt ===
# install plugin files into appropriate folder

FILE(GLOB PLUGINFILES README*.txt)
FILE(GLOB PLUGINPROGRAMS *.py)
INSTALL(PROGRAMS ${PLUGINPROGRAMS} DESTINATION ${HUGINDATADIR}/data/plugins)
INSTALL(FILES ${PLUGINFILES} DESTINATION ${HUGINDATADIR}/data/plugins)

=== debian/changelog ===
hugin (2025.0~rc1+dfsg-1) experimental; urgency=low

  * New upstream version.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 15 Nov 2025 15:49:18 +0100

## hugin 2025.0.0+dfsg

=== platforms/linux/appdata/CMakeLists.txt ===
IF (UNIX)
# install appdata files
  INSTALL(FILES calibrate_lens_gui.appdata.xml hugin.appdata.xml PTBatcherGUI.appdata.xml hugin_toolbox.appdata.xml DESTINATION ${DATADIR}/metainfo)
ENDIF (UNIX)

=== debian/changelog ===
hugin (2025.0.0+dfsg-1~mx25+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 20 Nov 2025 18:53:12 -0800

hugin (2025.0.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Wed, 19 Nov 2025 11:18:46 +0100

=== debian/control ===
--- 
+++ 
@@ -1,36 +1,32 @@
 Source: hugin
 Section: graphics
 Priority: optional
-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
-Uploaders:
- Andreas Metzler <ametzler@debian.org>,
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
+Uploaders: Andreas Metzler <ametzler@debian.org>
 # hugin can use Boost::Signal or in Boost >= 1.54 Boost::Signal2 which is
 # shipped in libboost-dev.
-Build-Depends:
- debhelper-compat (= 13),
- dh-python,
- cmake (>= 3.15),
- libepoxy-dev,
- libexiv2-dev (>= 0.12),
- libfftw3-dev,
- libflann-dev,
- liblcms2-dev,
- libopenexr-dev,
- libpano13-dev (>= 2.9.19~beta1),
- libsqlite3-dev,
- libtiff-dev,
- libvigraimpex-dev (>=1.9),
- libwxgtk3.2-dev,
- libx11-dev,
- pkgconf,
- python3-dev,
- python3-setuptools,
- swig (>= 2.0.4),
- zlib1g-dev,
-Build-Conflicts:
- wx2.6-headers,
- wx2.8-headers,
- wx3.0-headers,
+Build-Depends: debhelper-compat (= 13),
+               dh-python,
+               cmake (>= 3.15),
+               libepoxy-dev,
+               libexiv2-dev (>= 0.12),
+               libfftw3-dev,
+               libflann-dev,
+               liblcms2-dev,
+               libopenexr-dev,
+               libpano13-dev (>= 2.9.19~beta1),
+               libsqlite3-dev,
+               libtiff-dev,
+               libvigraimpex-dev (>=1.9),
+               libwxgtk3.2-dev,
+               libx11-dev,
+               pkgconf,
+               python3-dev,
+               python3-setuptools,
+               swig (>= 2.0.4),
+               zlib1g-dev
+Build-Conflicts: wx2.6-headers, wx2.8-headers, wx3.0-headers
 Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: http://hugin.sourceforge.net/
@@ -39,22 +35,18 @@
 
 Package: hugin
 Architecture: any
-Depends:
- enblend (>= 3.2),
- enfuse,
- hugin-tools (= ${binary:Version}),
- libimage-exiftool-perl,
- make,
- ${misc:Depends},
- ${shlibs:Depends},
-Breaks:
- hugin-bin (<< 0.7.0~svn),
-Replaces:
- hugin-bin (<< 0.7.0~svn),
- hugin-data (<< 0.7.0~svn),
- hugin-tools (<< 0.7.0~svn),
-Suggests:
- dcraw | rawtherapee | darktable,
+Depends: enblend (>= 3.2),
+         enfuse,
+         hugin-tools (= ${binary:Version}),
+         libimage-exiftool-perl,
+         make,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Breaks: hugin-bin (<< 0.7.0~svn)
+Replaces: hugin-bin (<< 0.7.0~svn),
+          hugin-data (<< 0.7.0~svn),
+          hugin-tools (<< 0.7.0~svn)
+Suggests: dcraw | rawtherapee | darktable
 Description: panorama photo stitcher - GUI tools
  Hugin is a panorama photo stitching program. Essentially, Hugin is a
  GUI frontend for Panorama Tools. Stitching is accomplished by using
@@ -73,20 +65,14 @@
 
 Package: hugin-tools
 Architecture: any
-Depends:
- hugin-data (= ${source:Version}),
- ${misc:Depends},
- ${python3:Depends},
- ${shlibs:Depends},
-Breaks:
- hugin-bin (<< 0.7.0~svn),
- ${python3:Breaks},
-Replaces:
- hugin-bin (<< 0.7.0~svn),
-Recommends:
- libpano13-bin,
-Provides:
- python-hsi,
+Depends: hugin-data (= ${source:Version}),
+         ${misc:Depends},
+         ${python3:Depends},
+         ${shlibs:Depends}
+Breaks: hugin-bin (<< 0.7.0~svn), ${python3:Breaks}
+Replaces: hugin-bin (<< 0.7.0~svn)
+Recommends: libpano13-bin
+Provides: python-hsi
 Description: panorama photo stitcher - commandline tools
  Hugin is a panorama photo stitching program.
  .
@@ -122,15 +108,10 @@
 
 Package: hugin-data
 Architecture: all
-Depends:
- ${misc:Depends},
- ${python3:Depends},
- ${shlibs:Depends},
-Breaks:
- ${python3:Breaks},
+Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
+Breaks: ${python3:Breaks}
 # imports of included plugins
-Suggests:
- python-wxgtk4.0,
+Suggests: python-wxgtk4.0
 Description: panorama photo stitcher - common data files
  Hugin is a panorama photo stitching program.
  .
